//+------------------------------------------------------------------+
//|                                             SHE_kanskigor.mq4 |
//|                                         Copyright  2006, Shurka |
//|                                                 shforex@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Shurka"
#property link      "shforex@narod.ru"
//
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
//

#define MAGIC 130306

extern double        Lots=0.1;         //    
extern int           Profit=35;        //  ,  0 -   
extern int           Stop=55;          //  ,  0 -   
extern int           Slippage=5;       // 
extern string        Symb="*";         //   .  *     
                                       //      EURUSD
extern string        StartTime="00:05";//    
//
extern int    NumberOfTry  = 5;                 //   
extern bool   UseSound     = True;              //   
//
extern string _P_Trailing = "----------  ";
extern bool UseTrailing      = True;        //  
extern bool ProfitTrailing   = True;        //   
extern int  TrailingStopBuy  = 50;          //   
extern int  TrailingStopSell = 50;          //   
extern int  TrailingStep     = 5;           //  
//
color  clModifyBuy  = DodgerBlue;      //    
color  clModifySell = Tomato;          //    
//
datetime             TimeStart;
double               stoplevel,profitlevel;
string               SMB;
bool                 trade=false;

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
int start()
{
   TrailingPositions();
   int      i,b;
   
   //      StartTime   TimeStart
   TimeStart=StrToTime(StartTime);
   //          5 ,      .
   //     trade .     ,   .
   if(CurTime()<TimeStart || CurTime()>TimeStart+300) { trade=false; return(0); }
   //  trade ,    .
   if(trade) return(0);
   //        ,    
   if(iOpen(SMB,PERIOD_D1,1)>iClose(SMB,PERIOD_D1,1)) b=OP_BUY; else b=OP_SELL;
   //  
   if(b==OP_BUY)
   {
      //  Stop   0,     0,  Ask-Stop
      if(Stop==0) stoplevel=0; else stoplevel=MarketInfo(SMB,MODE_ASK)-Stop*MarketInfo(SMB,MODE_POINT);
      //      
      if(Profit==0) profitlevel=0; else profitlevel=MarketInfo(SMB,MODE_ASK)+Profit*MarketInfo(SMB,MODE_POINT);
      //      Ask   stoplevel   profitlevel
      i=OrderSend(SMB,OP_BUY,Lots,MarketInfo(SMB,MODE_ASK),Slippage,stoplevel,profitlevel,NULL,MAGIC,0,Red);
      //    ,   torg   ,     
      if(i!=-1) trade=true;
   }
   //     ,    .
   if(b==OP_SELL)
   {
      if(Stop==0) stoplevel=0; else stoplevel=MarketInfo(SMB,MODE_BID)+Stop*MarketInfo(SMB,MODE_POINT);
      if(Profit==0) profitlevel=0; else profitlevel=MarketInfo(SMB,MODE_BID)-Profit*MarketInfo(SMB,MODE_POINT);
      i=OrderSend(SMB,OP_SELL,Lots,MarketInfo(SMB,MODE_BID),Slippage,stoplevel,profitlevel,NULL,MAGIC,0,Blue);
      if(i!=-1) trade=true;
   }
   return(0);
}
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
int init()
{
   int i;
   //    
   if(Symb=="*") SMB=Symbol(); else SMB=Symb;
   return(0);
}
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+

//
//+----------------------------------------------------------------------------+
//|                                                      a-SimpleTrailing.mqh  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  17.11.2005      .                  |
//|                  :                       |
//|              -    : #include <a-SimpleTrailing.mqh>          |
//|              -   start(): if (UseTrailing) TrailingPositions();    |
//+----------------------------------------------------------------------------+
/*
//-------    --------------------------------------------+
extern string _P_Trailing = "----------  ";
extern bool UseTrailing      = True;        //  
extern bool ProfitTrailing   = True;        //   
extern int  TrailingStopBuy  = 50;          //   
extern int  TrailingStopSell = 50;          //   
extern int  TrailingStep     = 5;           //  
*/
//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
void TrailingPositions(string sy="", int op=-1, int mn=-1) {
  double p, pp;
  int    i, k=OrdersTotal();

  if (sy=="") sy=Symbol();
  p=MarketInfo(sy, MODE_POINT);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(sy, MODE_BID);
            if (!ProfitTrailing || (pp-OrderOpenPrice())>TrailingStopBuy*p) {
              if (OrderStopLoss()<pp-(TrailingStopBuy+TrailingStep-1)*p) {
                ModifyOrder(sy, -1, pp-TrailingStopBuy*p, 0, clModifyBuy);//
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(sy, MODE_ASK);
            if (!ProfitTrailing || OrderOpenPrice()-pp>TrailingStopSell*p) {
              if (OrderStopLoss()>pp+(TrailingStopSell+TrailingStep-1)*p || OrderStopLoss()==0) {
                ModifyOrder(sy, -1, pp+TrailingStopSell*p, 0, clModifySell);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//=======================================================================================================
//+----------------------------------------------------------------------------+
//|                                                           |
//|  :                                                                |
//|    sy -    ("" -  )                    |
//|    pp -   ,                              |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                                                |
//+----------------------------------------------------------------------------+
void ModifyOrder(string sy="", double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
  if (sy=="") sy=Symbol();
  bool   fm;
  double pAsk=MarketInfo(sy, MODE_ASK);
  double pBid=MarketInfo(sy, MODE_BID);
  int    dg, err, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0) sl=OrderStopLoss();
  if (tp<0) tp=OrderTakeProfit();
  
  dg=MarketInfo(sy, MODE_DIGITS);
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);

  if (pp!=OrderOpenPrice() || sl!=OrderStopLoss() || tp!=OrderTakeProfit()) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) {
        if (UseSound) PlaySound("expert.wav"); break;
      } else {
        err=GetLastError();
        Print("Error(",err,") modifying order: ",ErrorDescription(err),", try ",it);
        Print("Ask=",pAsk,"  Bid=",pBid,"  sy=",sy,"  op="+GetNameOP(OrderType()),
              "  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}





